#include <stdio.h>
#include <stdlib.h>
#include "date.h"

int main(int argc, char *argv[])
{
  int year = 2000;
  int month = 1;
  int day;
  int dow;
  int total_days;
  int r,c,d, maxrow;
  DT_DATE *d1;

  char *month_ascii[] = { "January", "February", "March",
			  "April", "May", "June",
			  "July", "August", "September",
			  "October", "November", "December" };

  if (argc > 1)
    year = atoi(argv[1]);

  if (argc > 2)
    month = atoi(argv[2]);
  
  d1 = DT_mkdate(year,month,1);
  printf("%s %d\n", month_ascii[month-1], year);

  /*** The easy way ***/
  printf("Su Mo Tu We Th Fr Sa\n");
  maxrow = DT_cal_rows(d1);

  for (r = 0; r < maxrow; r++)
    {
      for (c = 0; c < 7; c++)
	{
	  d = DT_cal_row_col_to_day(d1, r, c);
	  
	  if (d == 0)
	    printf("   ");
	  else
	    printf("%2d ", d);
	}
      printf("\n");
    }


  /*** The fast way (37% faster, if it matters) ***/
  printf("\n\nSu Mo Tu We Th Fr Sa\n");
  dow = DT_dow(d1);
  total_days = DT_days_this_month(d1);
  DT_add_days(d1, -DT_dow(d1));

  for (day = -dow; day < total_days; day++)
    {
      if (day < 0)
	printf("   ");
      else
	printf("%2d ", day+1);

      if ((day+dow+1)%7 == 0)
	printf("\n");
    }

  printf("\n\n");

  return 0;
}
